(defclass attributes-scenario (scenario)
((object :initarg :my-object
         :accessor my-object
         :initform nil)
 (old-input :initarg :old-input
            :accessor old-input
            :initform '())
  ))





(defparameter ask-for-specification (make-instance 'mystep
                      :name "ask-for-specification"
                      :my-condition
                       (notc (lambdac #'(lambda (rest mystep)
                                      (prev-step-matches rest '("ask-for-specification") 2))))
            :my-action #'(lambda (self restaurant)
             (let* ((current-scene (current-scenario (waiter restaurant)))
                    (current-object (my-object current-scene)))
;;          (format t "~%Current-object is: ~a" current-object)
;;          (format t "~%current-scene is: ~a" current-scene)
                (cond ((eq (length (subclasses current-object)) 1)
                    (say w "~% Is ~a O.K.?" (car (subclasses current-object))))
                (t (format t "~% What kind of ~a would you like. We only have "
                             (reference-name current-object) )
                         (loop for  i from 0 to (- (length (subclasses current-object)) 2) do
                                (say w " ~a," (nth i (subclasses current-object)))
                          )
                             (say w " or ~a? " (nth (- (length (subclasses current-object)) 1) (subclasses current-object)))))
                   (setf (expecting-input (waiter restaurant)) t)
))))

(defparameter get-yes-answer (make-instance 'mystep
                    :name "get-yes-answer"
                    :input-condition (wordc :nec '(yes))
                    :my-condition (lambdac #'(lambda (rest mystep)
                       (prev-step-matches rest '("ask-for-specification") 2)))
                    :my-action #' (lambda (self restaurant)
                      (add-to-order-pad (car (subclasses (my-object (current-scenario (waiter restaurant))))) restaurant))))

(defparameter get-specification (make-instance 'mystep
                    :name "get-specification"
                    :input-condition (orc (list
                          (phrasec
                              (list
                                 anystring :nec 'customer
                                                (wildcard 0 2)
                                       '(want have order)
                                         :nec focus-np-cond))
                               (phrasec (list
                                   anystring :nec focus-np-cond))
                              ))
                          
                    :my-condition (orc (list
                               (spscorec :sc 1 :nec
                             (wordc :nec
                                   '(orderable-item)))
                          (lambdac #'(lambda (rest mystep)
                       (prev-step-matches rest '("ask-for-specification") 2)))
                           ))

                    :my-action #' (lambda (self restaurant)
                     ;;  (format t "~% new input is: ~a" (input (waiter restaurant)))
                       (let ((item-to-add (binding-values self 'focus))
                             (input-item '()))
                          (loop for item in item-to-add do
                            (setf input-item (initialize 
                                (make-instance (obj-class item))))
                     
       (setf (reference-name input-item) (string-downcase (form-in-text item)))
                      
                      (add-to-order-pad (order-pad restaurant) input-item)
(remove-item (order-pad restaurant) (my-object (current-scenario (waiter restaurant))))
                         (cond ((null (subclasses input-item))
                  (format t "~% ~a .  Sure!" (reference-name input-item))
                         (cond ((not (eq (subscenario input-item) nil))
                         (format t "~%OK")
                        (format t "~%a" (subscenario input-item))
                          (setf (item (subscenario input-item)) input-item)
                          (push (subscenario input-item) (scenario-stack (waiter restaurant))))))
                    
                        
                         (t (make-attributes-scenario input-item restaurant)
                      ;; (format t "~%MAKING-ATTRIBUTES-SCENARIO")
                           ))
       
                         
                       )))))

                      



(defun make-attributes-scenario (object restaurant)
(let ((new-scenario (make-instance 'attributes-scenario
                               :my-object object
                               :name "attributes-scenario"
                                 :steps (list ask-for-specification 
                                           get-specification get-yes-answer)
                                :end-condition
                           (lambdac #'(lambda (restaurant mystep)
        
 ;;                           (format t "~%Trying to test end-condition")
                            (prev-step-matches restaurant '("get-specification" "get-yes-answer") 2)))
                            )))
                                
(push new-scenario (scenario-stack (waiter restaurant)))
new-scenario
))








