;######################################################################
;#                                                                    #
;#                 GENERAL.SCE                                        #
;#                                                                    #
;#  Contents:                                                         #
;#     Parameters:                                                    #
;#       For conditions:  det-bound, focus-n, focus-np,               #
;#                        focus-np-def-det, focus-np-cond             #
;#       Steps:  listen, list-menu, washroom                          #
;#                                                                    #
;######################################################################
                     


;------------------------------------------------------------------
; Some short-forms that are useful for simplifying input-conditions
;------------------------------------------------------------------
(defparameter det-bound (phrasec (list
                             :nec
                             (make-instance 'pair
                                :head det
                                :tail 'determiner))))
(defparameter focus-n (phrasec (list :nec (make-instance 'pair
                                     :head 'orderable-item
                                     :tail 'focus))))
(defparameter focus-np (orc (list (phrasec (list :nec 
                                        det-bound
                                        (wildcard 0 2)
                                        'of
                                        :nec focus-n))
                          (phrasec (list :nec focus-n)))))
;;; (defparameter focus-np-det-opt (phrasec
;;;                                   (list det-nec
;;;                                      (wildcard 0 6)
;;;                                      :nec focus-np)))
;;; (defparameter focus-np-det-nec (phrasec 
;;;                                   (list :nec det-bound
;;;                                      (wildcard 0 6)
;;;                                      :nec  focus-n)))
(defparameter focus-np-def-det (phrasec 
                                  (list :nec def-det
                                     (wildcard 0 6)
                                     :nec focus-n)))

(defparameter focus-np-cond (make-instance 'phrase-cond))
(setf (necessary-conditions focus-np-cond)
         (list :nec
                  (orc (list (phrasec  (list 
                                          :nec focus-np
                                          :nec 'comma
                                          :nec focus-np-cond))
                          (phrasec (list 
                                      :nec focus-np
                                      :nec 'and
                                      :nec focus-np))
                          (phrasec (list 
                                      :nec focus-np
                                      :nec 'comma
                                      :nec 'and
                                      :nec focus-np))
                          (phrasec (list :nec focus-np))
                          ))))


                      

   
  (defparameter listen (make-instance 'mystep         
        	     	 :name "listen"
                	 :my-condition 
		           (lambdac #'(lambda (rest mystep)
  	                          (if (expecting-input (waiter rest))
                                                (make-instance 'results 
                                                    :success t :score 
                                                            100)
                                                 (make-instance 'results 
                                                       :success nil))))
                          :my-action #'(lambda (self restaurant)
                                          (let ((new-input'() )
                                                (temp1 '()))
                                             (setf *TRAP* 1)
                                             (say w "~%C: ")
                                             (setf new-input (read-line))
                      ;;if not in the start-dialogue scenario or post-dialogue
                      ;; scenario increment num-lines-read and add to line
                      ;; to the input being saved

                                (cond ((and (not 
	                                 (equal (name (current-scenario 
                                             (waiter restaurant))) 
                                                    "start-dialogue")) 
                                             (not 
                                           (equal (name (current-scenario 
                                              (waiter restaurant))) 
                                                "post-dialogue-analysis"))) 
                                            
                                             (setf (num-lines-read 
                                                   (waiter restaurant)) 
                                                    (+ 1 
                                                   (num-lines-read 
                                                     (waiter restaurant))))

                                         (setf temp1 (make-instance 'input-line
                                :line-num (num-lines-read (waiter restaurant))
                                                     :input new-input))
                                         (setf (user-input list-of-errors) 
                                          (push temp1 
                                              (user-input list-of-errors)))
))
;;(format t "~%User input: ~a" (user-input list-of-errors))
                                          
                                (format transcript new-input)
                                          ;   (format t "~%Time parsing: ")
                                          ;   (time 
                                   (setf new-input (parse (waiter restaurant) 
                                                                new-input))
                                           ;     )
                            (let ((temp '()))
                            (loop for a-word in (input (waiter restaurant)) do
                                   (if (typep a-word 'word)
                                   (setf temp
                                  (append (relevant-scenarios a-word) temp))))
                                (setf (input-expectations (waiter restaurant))
                                                      (reverse temp)))
                                             ))))
;----------------------------------
; Steps that apply in any scenario
;----------------------------------
  ;(format t "~%Beginning to build scenarios~%")
 
 

  (defparameter washroom (make-instance 'mystep
                           :name "washroom"
                            
                           :my-condition (spscorec :sc 5) 
                           :input-condition  (wordc :nec '(washroom)
                                                          :sup '(where be))
                           :my-action #'(lambda (self restaurant)
                                      (say w "~%The washroom's down the hall."
))))

 
  (defparameter list-menu (make-instance 'mystep
                          :name "list-menu"
                          :input-condition 
                                              (wordc :nec '(menu))
                          :my-condition (spscorec :sc 4)
                        
                          :my-action #'(lambda (self restaurant)
                                         (print-menu restaurant)
                    (if (equal (name (nth-last-step (waiter restaurant) 1)) 
                         "ask-drink-order")
                          (setf (expecting-input (waiter restaurant)) t))
                    (if (equal (name (nth-last-step (waiter restaurant) 1)) 
                         "ask-food-order")
                          (setf (expecting-input (waiter restaurant)) t))
         
                                          )))


  (defparameter general-scenario 
    (make-instance 'scenario
		   :parent nil
                   :name "general-scenario"
		   :steps (list list-menu washroom)))

  ;(format t "Finished building general-scenario steps~%")












