
;------------------------------
; Slot-scenario
;------------------------------


  (defparameter ask-yes-no (make-instance 'mystep
            :my-condition  (lambdac 
                              #'(lambda (rest mystep)
                                    (let ((previous-step 
                                            (last-step (waiter rest)))
                                         (waiter (waiter rest)))
                                      (cond 
                                            ((and (equal (name previous-step) 
                                                     "find-next-slot-to-fill")
                                                  (equal 
                                                     (gethash 
                                                        (slot (current-scenario waiter))
                                                        (parts (my-object (current-scenario waiter))))
                                                     yes-no))
                                             ;the slot expects a yes-no answer
                                             (make-instance 'results
                                                :success t :score 2))
                                            (t (make-instance 'results
                                                  :success nil  :score 0))))))
	    :name "ask-yes-no"
            :my-action #'(lambda (self restaurant)
                    (say w "~%For your ~a, would you like ~a?" 
                    (reference-name (my-object (current-scenario (waiter restaurant))))  
                    (string-downcase (string (slot (current-scenario (waiter  restaurant)))))
                      
                       )
                            (setf (expecting-input (waiter restaurant)) t)
                            )
            ))

  ;(format t "Finished building ask-yes-no step~%")

  (defparameter ask-choice (make-instance 'mystep
            :my-condition  (lambdac 
                              #'(lambda (rest mystep)
                                   (let* ((curr-scene (current-scenario (waiter rest)))
                                          (slot-value (gethash 
                                                         (slot curr-scene)
                                                         (parts (my-object curr-scene)))))
                                      (cond 
                                            ((and (not (equal slot-value yes-no))
                                                  (listp slot-value)
                                                  (not (null slot-value))
                                                  )
                                             ;the slot expects the answer to be one item
                                             ;from a list of items
                                             (make-instance 'results
                                                :success t :score 2))
                                            (t (make-instance 'results
                                                  :success nil  :score 0)))
                                      ;)
                                      )))
	    :name "ask-choice"
            :my-action #'(lambda (self rest)
                         (say w "~%For your ~a, would you like ~%" 
                            (reference-name (my-object (current-scenario (waiter rest)))))
                         (let ((value-range (gethash (slot (current-scenario (waiter rest)))
                                                     (parts (my-object (current-scenario (waiter 
                                                                                   rest)))))))
                          (say w "~a" (car value-range))
                          (loop for i from 1 to (- (length value-range) 2) do
                                (say w (string-downcase 
                                             (format nil ", ~a" (nth i value-range)))))
                          (say w " or ~a?" (string-downcase 
                                                 (format nil (first (last value-range)))))
                            (setf (expecting-input (waiter rest)) t)))
            ))

  ;(format t "Finished building ask-choice step~%")

  (defparameter get-yes-no-answer (make-instance 'mystep
            :input-condition  (orc (list  (wordc :nec '(yes))
                                      (wordc :nec '(no))))
            :my-condition (lambdac 
                                #'(lambda (restaurant mystep)
                                     (when debugp (format t "~%testing get-yes-no-answer"))
                                      (let ((previous-step 
                                            (last-step (waiter restaurant))))
                                       (cond 
                                        ((eq (name previous-step)(name ask-yes-no))
				      ;   (format t "~%get-yes-no-answer succeeds")  
					 (make-instance 'results
                                                :success t  :score 1))
					(t  (make-instance 'results
                                                :success nil :score 0))))))
            :name "get-yes-no-answer"
            :my-action #'(lambda (self restaurant)
                       (let* ((current-scene (current-scenario (waiter restaurant)))
                              (current-object (my-object current-scene)))
                  
                          (find-slot-fillers current-object (input (waiter restaurant)) restaurant)

                       (cond ((found-word 'yes (input (waiter restaurant)) 0)
                              (setf 
                               (gethash (slot current-scene) (parts current-object))
                               yes)

                              (say w (random-pick (list (format nil "~%~a with your ~a? Sure." 
                                                    (nstring-downcase 
                                                       (format nil "~a" (slot current-scene))
                                                       :start 1)
                                                    (string-downcase
                                                       (format nil "~a" current-object)))
                                              (format nil "~%~a? Okay." 
                                                 (nstring-downcase (format nil "~a" 
                                                                     (slot current-scene))
                                                    :start 1))
                                              (format nil "~%~a" (random-pick sure))))))
                             (t (setf 
                                 (gethash (slot current-scene) (parts current-object))
                                 no)

                                (say w "~a" (random-pick (list 
                                                (format nil "~% No ~a with your ~a, okay." 
                                                   (string-downcase 
                                                      (format nil "~a" (slot current-scene))) 
                                                    (string-downcase 
                                                      (format nil "~a" current-object)))
                                                (format nil "~%No ~a? ~a" 
                                                   (string-downcase (format nil "~a" 
                                                                       (slot current-scene)))
                                                   (random-pick sure)))))
                                                
                                )
                             )))
            ))

(defparameter get-choice-answer 
   (make-instance 'mystep
      :input-condition  (lambdac
                           #'(lambda (rest mystep)
                                (let ((possible-values 
                                         (gethash (slot (current-scenario
                                                           (waiter rest)))
                                            (parts (my-object (current-scenario
                                                                 (waiter rest))))))
                                      (count 0)
                                      (input-stream (input (waiter rest)))
                                      (found nil))
                                   (loop for word in possible-values until found do
                                      (setf count 0)
                                      (loop for input-word in input-stream until found do
                                         (cond ((items-match input-word word)
                                                (setf found t))
                                               (t (incf count)))
                                         ))
                                   (if found
                                      (make-instance 'results :success t :score (list count))
                                      (make-instance 'results :success nil :score nil))
                                   )))
        :my-condition      (lambdac 
                                   #'(lambda (restaurant mystep)
                                         (let ((previous-step 
                                                 (last-step (waiter restaurant) )))
                                           (cond 
                                                 ((eq (name previous-step)(name ask-choice))
                                                  (make-instance 'results
                                                     :success t  :score 1))
                                                 (t  (make-instance 'results
                                                        :success nil :score 0))))))
            :name "get-choice-answer"
            :my-action #'(lambda (self rest)
                           (let* ((current-scene (current-scenario (waiter rest))) 
                                  (current-object (my-object current-scene))
                                  (possible-values (gethash (slot current-scene) (parts current-object)))
                                  (input (input (waiter rest)))
                                  (found nil))
                        ;There was (at least) one word in the student's input 
                        ;that matches the possible options listed in the gethash.
                        ;Find that word (assume only one for now) and put it into the
                        ;hash table at the right spot.
                              (find-slot-fillers current-object (input (waiter rest)) rest)
                              (loop for word in possible-values until found do
                                 (loop for input-word in input until found do
                                    (cond ((items-match input-word word)
                                           (setf (gethash (slot current-scene) 
                                                    (parts (my-object (current-scenario 
                                                                         (waiter rest))))) word)
                                           (setf found t)))
                                    ))
                              (say w "~%~a? Sure." 
                                 (gethash (slot current-scene) 
                                    (parts (my-object (current-scenario (waiter rest))))))
                             
                             )) 
            ))

  (defparameter find-next-slot-to-fill
     (make-instance 'mystep
        :my-condition (spscorec :sc 1)
        :name "find-next-slot-to-fill"
        :my-action #'(lambda (self rest)
                        (let* ((parent-scenario (current-scenario (waiter rest)))
                              (object (my-object parent-scenario))
                              (unfilled-slot '()))
                           (maphash #'(lambda (key value)
                              (unless (slot-filled object key)
                                 (setf unfilled-slot key)))
                              (parts object))
                           (setf (slot (current-scenario (waiter rest))) unfilled-slot)
                           ))))
                           
                           
                             
  (defun make-slot-scenario  (object restaurant)
   ;We now have an object and the part, or slot, in it that we want to fill. 
   ;create an instance of the scenario and put it on the stack.
     (let ((new-scenario (make-instance 'slot-filler-scenario
                            :my-object object
                          ; :slot part
                            :name (reference-name object)
                            :parent order-scenario
                            :end-condition 
                            (lambdac #'(lambda (rest mystep)
                                          (let ((results (make-instance 'results :success t))
                                                (object (my-object (current-scenario (waiter 
                                                                                        rest)))))
                                             (maphash 
                                                #'(lambda (key value)
                                                      (unless (slot-filled object key)
                                                        (setf (success results) nil)))
                                                (parts object))
                                                results)
                                             )))
            ))
        (add-steps new-scenario  
           ;COMPLETE THIS LIST OF STEPS
           (list find-next-slot-to-fill ask-yes-no ask-choice get-yes-no-answer get-choice-answer))
        (push new-scenario (scenario-stack (waiter restaurant)))
        new-scenario
        ))


