(defclass subscenario (scenario)
((item :initarg :item
       :initform nil
       :accessor item)))

(defparameter ask-if-cream-or-sugar (make-instance 'mystep
         :name "ask-if-cream-or-sugar"
         :my-condition (spscorec :sc 1)
         :my-action #'(lambda (self restaurant)
          (say (waiter restaurant) "~%Would you like cream and sugar for your coffee?")
        (setf (expecting-input (waiter restaurant)) t))))

(defparameter get-both (make-instance 'mystep
         :name "get-both"
         :input-condition (orc (list (wordc :nec '(yes))
                                     (wordc :nec '(both))))
         :my-condition (lambdac #'(lambda (restaurant mystep)
                        (prev-step-matches restaurant '("ask-if-cream-or-sugar") 3)))
         :my-action #'(lambda (self restaurant)
          (say (waiter restaurant) "~%Cream and sugar?  No problem!"))))

(defparameter get-neither (make-instance 'mystep
        :name "get-neither"
        :input-condition (orc (list (wordc :nec '(no))
                                    (wordc :nec '(none))))
                     


(defparameter ask-if-wants-cream (make-instance 'mystep
          :name "ask-if-wants-cream"
          :my-condition (spscorec :sc 1 (andc :nec (list
                                  (notc (historyc "black-coffee"))
                                 (notc (historyc "get-cream"))
                                 (notc (historyc "do-not-get-cream"))
                                  (notc (historyc "ask-if-wants-cream")))))
          :my-action #'(lambda (self restaurant)
             (say (waiter restaurant) "~%Would you like cream in your coffee?")
             (setf (expecting-input (waiter restaurant)) t))))

(defparameter get-cream-and-sugar (make-instance 'mystep
          :name "get-cream-and-sugar"
          :input-condition (orc (list (andc :nec (list
                                                   (wordc :nec '(cream sugar))
                                                   (notc (wordc :nec '(no)))))
                                      (andc :nec (list (wordc :nec '(yes)) 
                                                      (notc (wordc :nec '(no)))
                                            (orc (list (wordc :nec '(cream))
                                                       (wordc :nec '(sugar))))))))
         : my-condition (orc (list 
                              (andc :nec (list (lambdac #'(lambda (restaurant mystep)
                                             (prev-step-matches restaurant
                                                 '("ask-if-wants-cream") 1)))
                                             (wordc :nec '(sugar))))
                              (andc :nec (list (lambdac #'(lambda (restaurant mystep)
                                             (prev-step-matches restaurant
                                                 '("ask-if-wants-sugar") 1)))
                                             (wordc :nec '(cream))))))
         :my-action #'(lambda (self restaurant)
               (say (waiter restaurant) "~%Cream and sugar?  No problem!"))))

(defparameter get-neither (make-instance 'mystep
         :name "get-neither"
         :input-condition (orc (list (wordc :nec '(without-cream without-sugar))
                                    (andc :nec (list (wordc :nec '(no))
                                     (orc (list (wordc :nec '(without-cream))
                                                 (wordc :nec '(without-sugar))))))))
         :my-condition (orc (list (andc :nec (list (lambdac #'(lambda (restaurant mystep)
                                         (prev-step-matches restaurant
                                             '("ask-if-wants-cream") 1)))
                                          (wordc :nec '(without-sugar))))
                                   (andc :nec (list (lambdac #'(lambda (restaurant mystep)
                                       (prev-step-matches restaurant '("ask-if-wants-sugar") 1)))
                                       (wordc :nec '(without cream))))))
         :my-action #'(lambda (self restaurant)
           (say (waiter restaurant) "~%No cream and no sugar?  All right.")))) 
                              


(defparameter get-cream (make-instance 'mystep
          :name "get-cream"
          :input-condition (wordc :nec '(cream))
          :my-condition (spscorec :sc 2)
          :my-action #'(lambda (self restaurant)
          (say (waiter restaurant) "~%Cream?  Sure!"))))



(defparameter do-not-get-cream (make-instance 'mystep
          :name "do-not-get-cream"
          :input-condition (wordc :nec '(without-cream))
                                   
          :my-condition (spscorec :sc 2 )
         
          :my-action #'(lambda (self restaurant)
           (say (waiter restaurant) "~%No cream?  No problem!")
)))



(defparameter ask-if-wants-sugar (make-instance 'mystep
          :name "ask-if-wants-sugar"
          :my-condition (andc :nec (list (historyc "ask-if-wants-cream")
                                    (andc :nec (list (notc (historyc "get-sugar"))
                                               (notc (historyc "yes-sugar"))
                                                (notc (historyc "get-cream-and-sugar"))
                                                (notc (historyc "black"))
                                                (notc (historyc "get-neither"))
                                                (notc (historyc "do-not-get-sugar"))))))
          :my-action #'(lambda (self restaurant)
             (say (waiter restaurant) "~%Would you like sugar in your coffee?")
             (setf (expecting-input (waiter restaurant)) t))))

(defparameter yes-sugar (make-instance 'mystep
          :name "yes-sugar"
          :input-condition (wordc :nec '(yes))
          :my-condition (lambdac #'(lambda (restaurant mystep)
                           (prev-step-matches restaurant '( "ask-if-wants-sugar") 2)))
          :my-action #'(lambda (self restaurant)
             (say (waiter restaurant) "~%Sugar? Sure!"))))

(defparameter no-sugar (make-instance 'mystep
           :name "no-sugar"
           :input-condition (wordc :nec '(no))
           :my-condition (lambdac #'(lambda (restaurant mystep)
                           (prev-step-matches restaurant '( "ask-if-wants-sugar") 2)))
          :my-action #'(lambda (self restaurant)
               (say (waiter restaurant) "~%No sugar? No problem!"))))

(defparameter yes-cream (make-instance 'mystep
          :name "yes-cream"
          :input-condition (wordc :nec '(yes))
          :my-condition (lambdac #'(lambda (restaurant mystep)
                           (prev-step-matches restaurant '("ask-if-wants-cream") 2)))
          :my-action #'(lambda (self restaurant)
             (say (waiter restaurant) "~%Cream? Sure!"))))

(defparameter no-cream (make-instance 'mystep
           :name "no-cream"
           :input-condition (wordc :nec '(no))
           :my-condition (lambdac #'(lambda (restaurant mystep)
                           (prev-step-matches restaurant '("ask-if-wants-cream" ) 2)))
          :my-action #'(lambda (self restaurant)
               (say (waiter restaurant) "~%No cream? No problem!"))))
            
                  

(defparameter get-sugar (make-instance 'mystep
          :name "get-sugar"
          :input-condition (wordc :nec '(sugar))
           
           :my-condition (spscorec :sc 2)
          
          :my-action #'(lambda (self restaurant)
          (say (waiter restaurant) "~%Sugar?  Sure!"))))



(defparameter do-not-get-sugar (make-instance 'mystep
          :name "do-not-get-sugar"
          :input-condition (wordc :nec '(without-sugar))
            
           :my-condition (spscorec :sc 2)
          :my-action #'(lambda (self restaurant)
           (say (waiter restaurant) "~%No sugar?  No problem!")
)))


  
(defparameter black-coffee (make-instance 'mystep
              :name "black-coffee"
              :input-condition (wordc :nec '(black))
              :my-condition (spscorec :sc 4 :nec (andc :nec (list
                               (notc (historyc "get-cream"))
                               (notc (historyc "yes-cream"))
                               (notc (historyc "get-sugar"))
                               (notc (historyc "yes-sugar")))
      ))
              :my-action #'(lambda (self restaurant)
                (say (waiter restaurant) "~%Black?  Sure!"))))

 

(defparameter coffee-scenario (make-instance 'subscenario
           :name "subscenario"
          
           :steps (list  no-sugar yes-sugar no-cream yes-cream get-sugar do-not-get-sugar get-cream do-not-get-cream
          get-neither get-cream-and-sugar black-coffee ask-if-wants-cream ask-if-wants-sugar)
           :end-condition (orc (list (historyc "get-neither")
                                     (historyc "black-coffee")
                                     (historyc "get-cream-and-sugar")
                                     (andc :nec (list (historyc "get-sugar")
                                                      (historyc "get-cream")))
                                     (andc :nec (list (historyc "do-not-get-sugar")
                                                      (historyc "get-cream")))
                                     (andc :nec (list (historyc "yes-sugar")
                                                      (historyc "no-cream")))
                                     (andc :nec (list (historyc "yes-sugar")
                                                      (historyc "yes-cream")))
                                     (andc :nec (list (historyc "no-sugar")
                                                      (historyc "yes-cream")))
                                     (andc :nec (list (historyc "no-sugar")
                                                      (historyc "yes-cream")))
                                     
                                     (andc :nec (list (historyc "get-sugar")
                                                       (historyc "do-not-get-cream")))
                                     (andc :nec (list (historyc "do-not-get-sugar")
                                                      (historyc "do-not-get-cream")))))
                                  
))




(defparameter ask-if-diet-or-regular (make-instance 'mystep
          :name "ask-if-diet-or-regular"
          :my-condition (spscorec :sc 2 :nec (andc :nec 
                                              (list
                                               (notc (historyc "get-diet"))
                                               (notc (historyc "get-regular"))
                                               (notc (historyc "ask-if-diet-or-regular")))))
          :my-action #'(lambda (self restaurant)
            (say (waiter restaurant) "~%For your ~a, would you like diet or regular?" (reference-name (item (current-scenario (waiter restaurant)))))
            (setf (expecting-input (waiter restaurant)) t)
            
)))

(defparameter get-diet (make-instance 'mystep
         :name "get-diet"
         :input-condition (wordc :nec '(diet))
         :my-action #'(lambda (self restaurant)
           (say (waiter restaurant) "~%Diet? Sure!"))))

(defparameter get-regular (make-instance 'mystep
        :name "get-regular"
        :input-condition (wordc :nec '(regular))
        :my-action #'(lambda (self restaurant)
           (say (waiter restaurant) "~%Regular? Sure!"))))

(defparameter pop-scenario (make-instance 'subscenario
           :name "subscenario"
           :steps (list ask-if-diet-or-regular get-diet get-regular)
           :end-condition (orc (list (historyc "get-regular")
                                     (historyc "get-diet")))
))

           



















