(defmethod do-likeliest-scenario ((self waiter) restaurant)
  :documentation "Get-best-scenario tries to find the best scenario. First
     preference is for the scenario on the top of the stack; next preference
     is for the scenario that occurs most frequently in the input-expectations."

   (let ((current-scenario-applies '())
         (temp '()))
        
      ;;;Initialize the current scenario (if it is not already initialized)  
      (if (null (current-scenario self))
         (setf (current-scenario self) (pop (scenario-stack self))))
    
      (when debugr (format t "~%~% Finding the best scenario"))
      (when debugr (format t "~%   current scenario: ~a" (current-scenario self)) )
      (when debugr (format t "~%   input: ~a" (input self)))
      (when debugr (format t "~%   scenario stack: ~a" (scenario-stack self))) 
   
     (incf *TRAP* 1) ;;;This is used to stop it from looping infinitely --  
                  ;;; it should only be needed in the debugging stage.
     (when debugr (format t "   Trap-value: ~a" *TRAP*))
     (unless (or (null (current-scenario self)) ;; i.e. the scenario-stack is empty    
                  (> *TRAP* *maxtrap*))
        (when debugr 
           (format t "~%   current-scenario-expected: ~a" (current-scenario-expected 
               self (current-scenario self) )))
     (cond ((input self)
            (calculate-scenarios-from-input self)
            (when debugr (format t "~%   input expectations: ~a" (input-expectations self)))
              (cond ((and (or (null (input-expectations self))
                              (current-scenario-expected self (current-scenario self) ))
                          (is-applicable (current-scenario self) restaurant))
                     (when debugr 
                        (format t   "~%   based on the input, we expect the current scenario to apply"))
                     (cond ((do-scenario-step self r) 
                            (when debugr (format t "~%   current scenario applied. Record it."))
                            (record self (current-scenario self))
                                                        )
                           (t (when debugr (format t "~%   current scenario was expected to apply, but did not 
for some reason. Try the input-expectations for another scenario that applies. If none does, the 
only thing we can do is get a new scenario from the scenario-stack and try to do it. BUT DON'T 
THROW OUT THE OLD SCENARIO IF IT'S NOT FINISHED YET!"))
                              (calculate-scenarios-from-input w)
                              (when debugr  (format t "~%   input expectations are now: ~a" 
                                               (input-expectations self))  
                                 (format t "~%   current scenario is now: ~a" (current-scenario self)))
                              (cond ((input-expectations self)
                                     (unless (is-finished (current-scenario self) restaurant)
                                        (push (current-scenario self) (scenario-stack self)))
                                     (get-scenario-from-input self (input-expectations self) restaurant)
                                     (do-likeliest-scenario self restaurant))
                                    (t ;;;Input doesn't apply to this scenario and doesn't point 
                                       ;;;to any other scenario. We can probably ignore it.
                                       (setf (input self) nil)
                                       (cond ((is-finished (current-scenario self) restaurant)
                                              (setf (current-scenario self) (pop (scenario-stack self)))
                                              (do-likeliest-scenario self restaurant))
                                             (t (format t "~%   state of confusion in do-likeliest-scenario")
                                                (setf temp (current-scenario self))
                                                (setf (current-scenario self) (pop (scenario-stack 
                                                                                      self)))
                                                (push temp (scenario-stack self))
                                                (do-likeliest-scenario self restaurant))
                                             )))    )))  ;;;end  (and(or(null...
                    (t ;;; DO SUBROUTINE B - there are input expectations but they don't involve 
                       ;;; the current scenario
                       (calculate-scenarios-from-input w)
                       (cond ((input-expectations self)  
                              (unless (is-finished (current-scenario self) restaurant)  
                                      (push (current-scenario self) (scenario-stack self)))
                              (get-scenario-from-input self (input-expectations self) restaurant)
                              (do-likeliest-scenario self restaurant))
                             (t (cond ((is-finished (current-scenario self) restaurant)
                                       (setf (current-scenario self) (pop (scenario-stack self)))
                                       (do-likeliest-scenario self restaurant))
                                      (t (when debugr (format t "~%   there is input, the current scenario is not applicable 
but isn't finished either. I think this is a state of confusion."))
                                         (setf temp (current-scenario self))
                                         (setf (current-scenario self) (pop (scenario-stack self)))
                                         (push temp (scenario-stack self))
                                         (do-likeliest-scenario self restaurant)
                                         ))))    ))
            (setf (input self) nil)
            )  ;;;end ((input self)...
           (t (when debugr (format t "~%   There is no input." ))
              (cond ((and (is-applicable (current-scenario self) restaurant)
                          (not (is-finished (current-scenario self) restaurant)))
                    (when debugr (format t "~%   scenario is applicable."))
                     (cond ((do-scenario-step self r) 
                    ;         (format t "~%    did scenario-step.")
                             (record self (current-scenario self)))
                           (t (when debugr (format t     "~%   scenario is applicable but no steps applied in it!?!?"))
                              (setf temp (current-scenario self))
                              (setf (current-scenario self) (pop (scenario-stack self)))
                              (push temp (scenario-stack self))
                              (do-likeliest-scenario self  restaurant) )))
                    (t (cond ((is-finished (current-scenario self) restaurant)
                              (when debugr (format t "~%   the current scenario no longer applies: chuck it."))
                              (setf (current-scenario self) (pop (scenario-stack self)))
                              (do-likeliest-scenario self restaurant))
                             (t (when debugr (format t ";;;PROBLEM: CURRENT SCENARIO IS NOT FINISHED BUT DOES NOT APPLY
                                ;;;AT THIS TIME, AND THERE IS NO INPUT TO SUGGEST WHAT TO DO NEXT"))
                                ))))))
        
        );unless
      );let 
   );defmethod