;########################################################################
;#                                                                      #
;#                      TEST.LSP                                        #
;#  CONTENTS:                                                           #
;#     parameter: words                                                 #
;#     Comment;  This file contains the dictionary and the code         #
;#               to start the system                                    #
;########################################################################

;;;------------------------------------------------------------
;;; A dictionary of words
;;;------------------------------------------------------------   
(defparameter words '())

(setf  words 
       (make-instance 'dictionary 
		      :contents 
		      (list
	     ;wh-words     
		       (make-instance 'word
				      :pos "wh"
				      :base-form 'how
				      :special-phrases '("how are you" 
							 "how are things" 
							 "how is life"))
		       (make-instance 'word
				      :pos "wh"
				      :base-form 'what)
		       (make-instance 'word
				      :pos "wh"
				      :base-form 'where)
             ;pronouns
		       (make-instance 'pronoun
				      :base-form 'I
				      :special-forms '("me" "myself")
				      :obj-class 'customer
				      :description 
				      "You are talking about yourself.")
		       (make-instance 'pronoun
				      :base-form 'you
				      :obj-class 'waiter
				      :special-forms '("waiter" "yourself")
				      :description 
				      "You are talking about me.")
             ;drinks       
		       (make-instance 'noun
				      :base-form 'drink
				      :obj-class 'drink-item
				      :relevant-scenarios (list drink-order)
				      :special-forms '("drinks" "beverage" 
						       "beverages")
				      :description 
				      "A drink is a liquid.  Here we offer coffee tea and a variety of soft-drinks.")
		       (make-instance 'noun
				      :base-form 'hot-drink
				      :obj-class 'hot-drink
				      :relevant-scenarios (list drink-order)
				      :special-forms '("hot drink" "hot drinks"
						       " a hot drink")
				      :description "Hot drinks are warms liquids.  Here we offer coffee and tea.")
		       (make-instance 'noun
				      :base-form 'coffee
				      :obj-class 'coffee
				      :relevant-scenarios (list drink-order)
				      :special-forms '("java")
				      :special-phrases '("regular coffee")
				      :description "Coffee is a slightly bitter hot drink. We serve it with milk or sugar on the side." )
		       (make-instance 'noun
				      :base-form 'tea
				      :obj-class 'tea
				      :relevant-scenarios (list drink-order)
				      :description "Tea is a drink made from the leaves of a plant. Black tea is slightly bitter, but herb teas are often sweeter.")
		       (make-instance 'noun
				      :base-form 'hot-chocolate
				      :obj-class 'hot-chocolate
				      :relevant-scenarios (list drink-order)
				      :special-forms '("hot chocolate")
				      :description "Hot chocolate is a milky, chocolate flavoured hot drink.")
		       (make-instance 'noun
				      :base-form 'cold-drink
				      :obj-class 'cold-drink
				      :special-forms '("cold drink" 
						       "cold drinks")
				      :description "A cold drink is a chilled beverage. Here we offer a variety of soft-drinks."
				      :relevant-scenarios (list drink-order))
		       (make-instance 'noun
				      :base-form 'water
				      :obj-class 'water
				      :special-forms '("ice water" 
						       "water with ice" 
						       "ice-water")
				      :relevant-scenarios (list drink-order)
				      :description "Water is a cold drink that does not contain calories.")
		       (make-instance 'noun
				      :base-form 'alcoholic-beverage
				      :obj-class 'alcoholic-beverage
				      :relevant-scenarios (list drink-order)
				      :special-forms '("beer" "wine" "cocktail"
						       "vodka" "rum" "rye"))
		       (make-instance 'noun
				      :base-form 'iced-tea
				      :obj-class 'iced-tea
				      :relevant-scenarios (list drink-order)
				      :special-forms '("ice tea" "ice-tea" 
						       "iced tea")
				      :description "Iced-tea is a chilled sweetened herbal tea.")
		       (make-instance 'noun
				      :base-form 'milk
				      :obj-class 'milk
				      :relevant-scenarios (list drink-order)
				      :special-forms '()
				      :description "Milk is a cold drink. It is a dairy product that is rich in calcium.")
		       (make-instance 'noun
				      :base-form 'soft-drink
				      :obj-class 'soft-drink
				      :special-forms '("soft-drinks" 
						       "a soft-drink" 
						       "soft drink" "pop")
				      :relevant-scenarios (list drink-order)
				      :description "Soft-drink refers to any type of carbonated drink. It comes in 
various flavours. Cola is caramel coloured and sweet. Sprite is 
lemon-lime flavoured. Orange-crush is orange flavoured
and root beer is sort of minty.")
		       (make-instance 'noun
				      :base-form 'orange-crush
				      :obj-class 'orange-crush
				      :relevant-scenarios (list drink-order)
				      :special-forms '("orange crush" "orange"
						       "crush")
				      :description "Orange pop is a carbonated drink that's sort of orange flavoured.")
		       (make-instance 'noun
				      :base-form 'cola
				      :obj-class 'cola
				      :description "Cola is a carbonated drink. It's brown and sweet."
				      :special-forms '("coke" "pepsi")
				      :relevant-scenarios (list drink-order))
		       (make-instance 'noun
				      :base-form 'sprite
				      :obj-class 'sprite
				      :description "Sprite is a lemon-lime flavoured carbonated drink that is clear in colour."
				      :special-forms '("lemon-lime" "7up")
				      :relevant-scenarios (list drink-order))
		       (make-instance 'noun
				      :base-form 'soda
				      :obj-class 'soft-drink
				      :description "Soda water is just carbonated water."
                        :special-forms '("carbonated water" "club soda" 
					 "soda water")
                        :relevant-scenarios (list drink-order))
		       (make-instance 'noun
				      :base-form 'root-beer
				      :obj-class 'root-beer
				      :special-forms '("root beer" "rootbeer")
				      :description "Root beer is a carbonated drink. It tastes a bit minty."
                       
				      :relevant-scenarios (list drink-order))
		       (make-instance 'noun
				      :base-form 'cream-soda
				      :obj-class 'cream-soda
				      :description "Cream soda is a pink carbonated drink that tastes a bit milky."
				      :special-forms '("cream soda")
				      )
		       (make-instance 'noun
				      :base-form 'ginger-ale
				      :obj-class 'ginger-ale
				      :description "Ginger ale is  a carbonated drink. It tastes fainly gingery."
				      :special-forms '("ginger ale" "gingerale"
						       )
				      )
		       (make-instance 'noun
				      :base-form 'other-drinks
				      :obj-class 'other-drinks
				      :special-forms '("espresso" "cappucino"))
		       
             ;food-items
		       (make-instance 'noun
				      :base-form 'dessert-item
				      :obj-class 'dessert-item
				      :relevant-scenarios (list dessert-order)
				      :special-forms '("dessert" "desserts")
				      :description "Dessert is something that is eaten after a meal.  It is usually sweet. Here we serve cake and ice-cream.")
		       (make-instance 'noun
				      :base-form 'cake
				      :obj-class 'cake
				      :relevant-scenarios (list dessert-order)
				      :description "Cake is a kind of dessert. Except for cheesecakes, which are quite heavy, cake is often light and fluffy and spongy.")
		       (make-instance 'noun
				      :base-form 'chocolate-cake
				      :obj-class 'chocolate-cake
				      :relevant-scenarios (list dessert-order)
				      :special-forms '("chocolate cake" 
						       "chocolate")
				      :description "Chocolate cake is a light, fluffy chocolate-flavoured dessert.")
		       (make-instance 'noun
				      :base-form 'cheesecake
				      :obj-class 'cheesecake
				      :relevant-scenarios (list dessert-order)
				      :special-forms '("cheese-cake" 
						       "cheese cake")
				      :description "Cheesecake is a heavy dessert.")
		       (make-instance 'noun
				      :base-form 'ice-cream
				      :obj-class 'ice-cream
				      :relevant-scenarios (list dessert-order)
				      :special-forms '("ice cream")
				      :description "Ice-cream is a frozen, dairy dessert.")
                                           
		       (make-instance 'noun
				      :base-form 'vanilla-ice-cream
				      :obj-class 'vanilla-ice-cream
				      :relevant-scenarios (list dessert-order)
				      :special-forms '("vanilla ice cream" 
						       "vanilla ice-cream" 
						       "vanilla")
				      :description "Vanilla ice-cream is a frozen, dairy dessert.")
		       (make-instance 'noun
				      :base-form 'strawberry-ice-cream
				      :obj-class 'strawberry-ice-cream
				      :relevant-scenarios (list dessert-order)
				      :special-forms '("strawberry ice-cream" 
						       "strawberry ice cream" 
						       "strawberry")
				      :description "Strawberry ice-cream is a frozen, dairy dessert.")
		       
		       (make-instance 'noun
				      :base-form 'food-item
				      :obj-class 'food-item
				      :special-forms '("food")
				      :relevant-scenarios (list food-order)
				      :description "Food is anything that we eat. Here we have steak, fries and pasta.")
		       (make-instance 'noun
				      :base-form 'pasta
				      :obj-class 'pasta
				      :relevant-scenarios (list food-order)
				      :special-forms '("noodles")
				      :description "Pasta is a dish of noodles served with some kind of sauce. 
Here we have spaghetti and ravioli.")
		       (make-instance 'noun
				      :base-form 'spaghetti
				      :obj-class 'spaghetti
				      :relevant-scenarios (list food-order)
				      :description "Spaghetti is a pasta with a red meat-sauce.")
		       (make-instance 'noun
				      :base-form 'ravioli
				      :obj-class 'ravioli
				      :relevant-scenarios (list food-order)
				      :description "Ravioli is a meat-filled pasta topped with
a red sauce.")
		       (make-instance 'noun
				      :base-form 'burger
				      :special-forms ' ("burgers" "burger")
				      :obj-class 'burger
				      :relevant-scenarios (list food-order)
				      :description "A burger is a meat pattie wrapped in a bun and with some toppings on it. Our burgers come with ketchup, mustard and pickles.")
		       (make-instance 'noun
				      :base-form 'cheeseburger
				      :obj-class 'cheeseburger
				      :relevant-scenarios (list food-order)
				      :special-forms '("cheeseburgers" 
						       "cheese burger" 
						       "hamburger with cheese"
						       "cheeseburgers")
				      :description "A cheeseburger is a meat pattie with cheese on the top wrapped in a bun.  Our cheeseburger also come with ketchup, mustard and pickles.")
		       (make-instance 'noun
				      :base-form 'hamburger
				      :obj-class 'hamburger
				      :relevant-scenarios (list food-order)
				      :special-forms '("hamburgers" 
						       "plain burger" 
						       "burger with nothing on it")
				      :description "A plain burger is a meat pattie wrapped in a bun with no toppings.")
		       (make-instance 'noun
				      :base-form 'deluxe-burger
				      :obj-class 'deluxe-burger
				      :relevant-scenarios (list food-order)
				      :special-forms '("deluxe burger" 
						       "deluxe hamburger" 
						       "deluxe")
				      :description "A deluxe-burger is a meat pattie wrapped in a bun, topped with tomato, onions, lettuce, pickles, ketchup, mustard and pickle.")
		       (make-instance 'noun
				      :base-form 'fries
				      :special-forms '("french fries" "chips")
				      :obj-class 'fries
				      :relevant-scenarios (list food-order)
				      :description "French fries are deep-fried, salted, potato sticks.")
		       (make-instance 'noun
				      :base-form 'steak
				      :obj-class 'steak
				      :relevant-scenarios (list food-order)
				      :description "Steak comes from cows.  Here we serve steak rare, medium or well-done.")
     ;;non-orderable-items:
		       (make-instance 'noun
				      :base-form 'other-pastas
				      :obj-class 'other-pastas
				      :special-forms '("fettucini" "linguini" 
						       "lasagna"))
		       (make-instance 'noun
				      :base-form 'pizza
				      :obj-class 'pizza
				      )
		       (make-instance 'noun
				      :base-form 'other-meats
				      :obj-class 'other-meats
				      :special-forms '("pork" "pork-chops" 
						       "ribs" "veal" "fish" 
						       "lobster" "crab" 
						       "seafood"))
                  
		       (make-instance 'noun
				      :base-form 'chicken
				      :obj-class 'chicken
                     
				      :special-forms '("chicken" 
						       "chicken parmesian" 
						       "chicken sandwich"))
		       (make-instance 'noun
				      :base-form 'donut
				      :obj-class 'donut
				      )
		       (make-instance 'noun
				      :base-form 'sandwich
				      :obj-class 'sandwich
				      )
		       
		       (make-instance 'noun
				      :base-form 'salad
				      :obj-class 'salad
				      :special-forms '("lettuce"))
		       (make-instance 'noun
				      :base-form 'pie
				      :obj-class 'pie)
					;slot words
		       (make-instance 'word
				      :base-form 'rare
				      )
		       (make-instance 'word
				      :base-form 'medium
				      )
		       (make-instance 'word
				      :base-form 'well-done
				      :special-forms '("well done"))
		       (make-instance 'word
				      :base-form 'both
				      )
		       (make-instance 'word
				      :base-form 'diet
				      )
		       (make-instance 'word
				      :base-form 'regular
				      :special-forms '("normal"))
		       (make-instance 'word
				      :base-form 'cream
				      :description "Cream is a wilk cream liquid that is often added to coffee."
				      )
		       (make-instance 'word
				      :base-form 'without-cream
				      :special-forms '("without cream" 
						       "no cream" "not cream" 
						       "not milk"))
		       (make-instance 'word
				      :base-form 'sugar
				      )
		       (make-instance 'word
				      :base-form 'without-sugar
				      :special-forms '("without sugar" 
						       "no sugar" "not sugar"))
		       (make-instance 'word
				      :base-form 'black)
		       (make-instance 'word
				      :base-form 'or
                       )
          ;Other words
		       (make-instance 'word
				      :base-form 'with
				      )
		       (make-instance 'word
				      :base-form 'that
				      :special-forms '("those"))
		       (make-instance 'word
				      :base-form 'maybe
				      )
		       (make-instance 'word
				      :base-form 'later
				      :special-forms '("later-on" "not now"))
		       (make-instance 'word
				      :base-form 'cost
				      :special-forms '("price"))
		       (make-instance 'word
				      :base-form 'much
				      )
		       
		       (make-instance 'word
				      :base-form 'smoking
				      )
		       (make-instance 'word
				      :base-form 'non-smoking
				      :special-forms '("non smoking"))
		       (make-instance 'word
				      :base-form 'bill
				      :special-forms '("cheque" "total")
				      :relevant-scenarios (list end-scenario))
		       (make-instance 'word
				      :base-form 'washroom
				      :special-forms '("toilet" "toilets" 
						       "washrooms" "wc" 
						       "bathroom" "loo" 
						       "boy's room"))
		       (make-instance 'word
				      :base-form 'menu
				      :special-forms '("list" "special" 
						       "specials"))
		       (make-instance 'word
				      :base-form 'kind-of
				      :special-forms '("kind of" "kinds of" 
						       "types of" "type of" 
						       "kind" "type" 
						       "sorts of" "sort of"))
		       (make-instance 'word
				      :base-form 'forget-it
				      :special-forms '("never mind" "forget it"
						       "it's all right" 
						       "forget about it" 
						       "stop" "let me go" 
						       "had enough"
						       "leave"))
	   ;yes, no, please 
          ;and thank-you 
		       (make-instance 'word
				      :base-form 'yes
				      :special-forms '("yeah" "yep" "yup" "ya"
						       "sure" "okay" "ok" 
						       "o.k." "O.K." "OK"))
		       (make-instance 'word
				      :base-form 'no
				      :special-forms '("nope" "naw" "not" 
						       "never" "'t"))
		       (make-instance 'word
				      :base-form 'none
				      :special-forms '("neither"))
		       (make-instance 'word
				      :base-form 'nothing)
		       (make-instance 'word
				      :base-form 'please)
		       (make-instance 'word
				      :base-form 'thanks
				      :special-forms '("thank-you" "thank you")
				      )
		       (make-instance 'word
				      :base-form 'about)
		       (make-instance 'word
				      :base-form 'and)
		       (make-instance 'word
				      :base-form 'here)
		       (make-instance 'word
				      :base-form 'category
				      :special-forms '("categories"))
		       (make-instance 'word
				      :base-form 'row
				      :special-forms '("rows" "row numbers" 
						       "number" "numbers"))
         ;verbs
		       (make-instance 'verb
				      :base-form 'want
				      :special-forms '("wants" "wanted" 
						       "wanting"))
		       (make-instance 'verb
				      :base-form 'see
				      :special-forms '("saw" "seen" "look at"))
		       (make-instance 'verb
				      :base-form 'serve
				      :special-forms '("offer" "served" 
						       "serves" "sell" "sells")
				      )
		       (make-instance 'verb
				      :base-form 'order
				      :special-forms '("ordered" "orders"))
		       (make-instance 'verb
				      :base-form 'cancel
				      :special-forms '("cancelled" "cancels"))
		       (make-instance 'verb
				      :base-form 'have
				      :special-forms '("has" "had")
				      :theta-struct '(((animate actor) 
						       (inanimate object)) 
						      ((animate benefactor) 
						       (inanimate  object))))
		       (make-instance 'word
				      :pos "aux"
				      :base-form 'have
				      :special-forms '("has" "had" "'d"))
		       (make-instance 'word
				      :pos "aux"
				      :base-form 'will
				      :special-forms '("'ll" "would" "'d" 
						       "won't"))
		       (make-instance 'word
				      :pos "aux"
				      :base-form 'can
				      :special-forms '("could"))
		       (make-instance 'word
				      :pos "adv"
				      :base-form 'fine)
		       (make-instance 'verb
				      :base-form 'be
				      :special-forms '("am" "is" "are" "was" 
						       "were"))
	    ;adjectives
		       (make-instance 'word
				      :base-form 'great
				      :special-forms '("delicious" "amazing" 
						       "wonderfull" "good"))
                    
		       (make-instance 'word 
				      :base-form 'terrible
				      :special-forms '("awful" "dreadful" 
						       "rotten" "horrible" 
						       "bad"))
       ;determiners
		       ;;(make-instance 'determiner
		       ;; :definite t
		       ;; :base-form 'the)
		       (make-instance 'determiner
				      :base-form 'a
				      :special-forms '("an" "one" "some" 
						       "the"))
		       (make-instance 'determiner 
				      :base-form 'another
				      :special-forms '("more"))
		       (make-instance 'determiner
				      :base-form 'two
				      :number 2
				      :special-forms '("2"))
		       (make-instance 'determiner
				      :base-form 'three
				      :number 3
				      :special-forms '("3"))
                    (make-instance 'determiner
				   :definite t
				   :base-form 'my)
                    (make-instance 'determiner
				   :base-form 'her
				   :definite t
				   :special-forms '("his"))
                    (make-instance 'determiner
				   :base-form 'our
				   :definite t
				   :number 2)
	 ;prepositions
                    (make-instance 'punctuation
				   :base-form 'of
				   :special-forms '("of"))
        ;punctuation
                    (make-instance 'punctuation
				   :base-form 'comma
				   :special-forms '(","))
                    (make-instance 'punctuation
				   :base-form 'period
				   :special-forms '("."))
                    (make-instance 'punctuation
				   :base-form 'question-mark
				   :special-forms '("?"))   
                       
                       
		    )))


;-------------------------------
;  Setting up the waiter & stuff
;-------------------------------
(defparameter w '())
(initialize words)
(initialize wrong-words)
(defun prepare ()
  (setf  w (make-instance 'waiter
			  :name "Mathilda"
			  :scenarios (list greeting drink-order serve 
					   food-order dessert-order 
					   end-scenario wrap-up)
			  :scenario-stack (list start-dialogue)
			  :current-scenario '()
			  :dictionary words
			  :non-dictionary wrong-words
			  ))
  (defparameter r (make-instance 'restaurant
				 :waiter w))
  )

(prepare)
(defun visit ()
  (prepare)
  (run r)
  (dump-object (order-pad r) t))



;;; PUT INSTRUCTIONS FOR RUNNING THE SIMULATION RIGHT
;;; HERE!



(run r)






























